## casacore 2.4.1

=== CMakeLists.txt ===
#
# Casacore
#
project(casacore)

cmake_minimum_required (VERSION 2.6.0)
include(CheckCXXCompilerFlag)
include(CheckCCompilerFlag)
include(CheckFunctionExists)

# fixes warnings on cmake 3.x+ For now we want the old behavior to be backwards compatible
if (POLICY CMP0048)
    cmake_policy (SET CMP0048 OLD)
endif()

set(PROJECT_VERSION_MAJOR 2)
set(PROJECT_VERSION_MINOR 4)
set(PROJECT_VERSION_PATCH 0)
set(PROJECT_VERSION_REVISION 1)
set(PROJECT_VERSION 
  "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

SET(NO_SOVERSION FALSE CACHE BOOL "do not add version information to shared libraries")
set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

set(CPACK_GENERATOR "DEB")
set(CPACK_PACKAGE_NAME "casacore")
set(CPACK_PACKAGE_VERSION "${PROJECT_VERSION}")

set(CPACK_PACKAGE_CONTACT "Malte Marquarding") #required
set(CPACK_PACKAGE_VENDOR "casacore.googlecode.com")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Astronomical data processing library")

string(TOLOWER "${CPACK_PACKAGE_NAME}" CPACK_PACKAGE_NAME_LOWERCASE) 
find_program(DPKG_PROGRAM dpkg DOC "dpkg program of Debian-based systems") 
if(DPKG_PROGRAM) 
  execute_process( 
    COMMAND ${DPKG_PROGRAM} --print-architecture 
    OUTPUT_VARIABLE CPACK_DEBIAN_PACKAGE_ARCHITECTURE 
    OUTPUT_STRIP_TRAILING_WHITESPACE 
  ) 
  set( CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME_LOWERCASE}-dev_${PROJECT_VERSION}-${PROJECT_VERSION_REVISION}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")   

else() 
  set(CPACK_PACKAGE_FILE_NAME 
"${CPACK_PACKAGE_NAME_LOWERCASE}_${PROJECT_VERSION}-${PROJECT_VERSION_REVISION}_${CMAKE_SYSTEM_NAME}") 
endif() 

# debian specific
set(CPACK_DEBIAN_PACKAGE_NAME "casacore-dev")
set(CPACK_DEBIAN_PACKAGE_SECTION "science")
set(CPACK_DEBIAN_PACKAGE_PRIORITY "extra")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libcfitsio3, libgfortran3")
include(CPack)

enable_language (Fortran)

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# By default build only Python2 bindings
option (BUILD_PYTHON "Build the python bindings" YES)
option (BUILD_PYTHON3 "Build the python3 bindings" NO)

# By default build shared libraries
option (ENABLE_SHARED "Build shared libraries" YES)

option (ENABLE_RPATH "Include rpath in executables and shared libraries" YES)

# By default do not use HDF5, FFTW3, threads
option (CXX11 "Compile as C++11 if possible" YES)
option (ENABLE_TABLELOCKING "Make locking for concurrent table access possible" YES)
option (USE_HDF5 "Build HDF5 " NO)
option (USE_FFTW3 "Use FFTW instead of FFTPack" NO)
option (USE_THREADS "Use Mutex thread synchronization" NO)
option (USE_OPENMP "Use OpenMP threading" NO)
option (USE_STACKTRACE "Show stacktrace in case of exception" NO)
option (CASA_BUILD "Building in the CASA (http://casa.nrao.edu) environment" NO)

set(CASA_DEFAULT_ALIGNMENT "32" CACHE STRING "Default alignment of casa::AlignedAllocator")

# ccache use is optional
option( UseCcache OFF )

if (UseCcache)
    message (STATUS "Searching for ccache.")
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        message (STATUS "Ccache found.")
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif(CCACHE_FOUND)
endif()


# basic setup for building within CASA environment
if( CASA_BUILD )
   if( NOT DATA_DIR )
      set(DATA_DIR "%CASAROOT%/data")
   endif( )
   set(USE_FFTW3 ON)
   set(USE_OPENMP ON)
   set(USE_THREADS ON)
   set(UseCasacoreNamespace 1) # Force casacore routines to live in casacore rather than casa namespace
   ###
   ### after CASA switches from ASAP to libsakura, CASA will no longer
   ### use casacore's python module and it will no longer use boost...
   ###
   set(BUILD_PYTHON ON)
   set(Boost_NO_BOOST_CMAKE 1)
   if (EXISTS "/opt/casa/02/include/python2.7")
      ### RHEL7
      set(PYTHON_LIBRARY "/opt/casa/02/lib/libpython2.7.so")
      set(PYTHON_INCLUDE_DIR "/opt/casa/02/include/python2.7")
      set(NUMPY_INCLUDE_DIRS "/opt/casa/02/lib/python2.7/site-packages/numpy/core/include")
      set(PYTHON_EXECUTABLE:FILEPATH "/opt/casa/02/bin/python")
      if (EXISTS "/usr/include/boost")
         set(BOOST_ROOT "/usr")
      endif( )
      set(WCSLIB_INCLUDE_DIR "/opt/casa/02/include")
      set(WCSLIB_LIBRARY "/opt/casa/02/lib/libwcs.so")
      set(PYTHON2_NUMPY_INCLUDE_DIRS "/opt/casa/02/lib/python2.7/site-packages/numpy/core/include")
   elseif (EXISTS "/opt/casa/01/include/python2.7")
      ### RHEL7
      set(PYTHON_LIBRARY "/opt/casa/01/lib/libpython2.7.so")
      set(PYTHON_INCLUDE_DIR "/opt/casa/01/include/python2.7")
      set(PYTHON_EXECUTABLE:FILEPATH "/opt/casa/01/bin/python")
      if (EXISTS "/usr/include/boost")
         set(BOOST_ROOT "/usr")
      endif( )
   elseif(EXISTS "/usr/lib64/casa/01/include/python2.7")
      ### RHEL5/RHEL6
      set(PYTHON_LIBRARY "/usr/lib64/casa/01/lib/libpython2.7.so")
      set(PYTHON_INCLUDE_DIR "/usr/lib64/casa/01/include/python2.7")
      set(PYTHON_EXECUTABLE:FILEPATH "/usr/lib64/casa/01/bin/python")
      if (EXISTS "/usr/lib64/casa/01/include/boost")
         ### RHEL5
         set(BOOST_ROOT "/usr/lib64/casa/01")
      elseif (EXISTS "/usr/include/boost")
         ### RHEL6
         set(BOOST_ROOT="/usr")
      endif( )
   endif( )
endif( )

# Test if shared libraries have to be built.
if (ENABLE_SHARED)
    option (BUILD_SHARED_LIBS "" YES)
    if (ENABLE_RPATH)
        # Set RPATH to use for installed targets; append linker search path
        set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib" )
        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
        set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
        set(CMAKE_MACOSX_RPATH TRUE)
    endif (ENABLE_RPATH)
	if( CASA_BUILD )
		set(CXX11 ON)
		option(NO_SOVERSION "Build shared libraries without version information" NO)
		if( NOT NO_SOVERSION )
			set( epochdelta 1385614800 )
			execute_process( COMMAND perl -e "$t=time( )-${epochdelta};$z=$t & 0xff; $y=($t>>8)&0xff; $x=($t>>16)&0xffff; print \"$x.$y.$z\""
					         OUTPUT_VARIABLE __casa_soversion )
			set(casa_soversion ${__casa_soversion} CACHE STRING "version for shared objects")
			message( STATUS "Shared object version number ${casa_soversion}" )
			file( WRITE ${CMAKE_INSTALL_PREFIX}/casa_sover.txt
				  "# generated by casacore/CMakeList.txt... Do not edit\n"
				  "${casa_soversion}\n" )
		else( )
			message( STATUS "User disabled shared library versioning" )
		endif( )
	endif( )
else()
    option (BUILD_SHARED_LIBS "" NO)
endif (ENABLE_SHARED)

if (UseCasacoreNamespace)

    add_definitions (-DUseCasacoreNamespace)
    message (STATUS "Using namespace casacore.")

else ()

    message (STATUS "Namespace casacore 'merged' into namespace casa.")

endif ()

# Define the compiler flags to be used.
# Note: -Wshadow and -Wunreachable-code give (too) many warnings.
# Casacore uses longlong, so no warnings for it.
# Clang gives warning on bison generated code; disable unneeded-internal-declaration.
if (NOT CMAKE_CXX_FLAGS)
    set (CMAKE_CXX_FLAGS "-Wextra -Wall -W -Wpointer-arith -Woverloaded-virtual -Wwrite-strings -pedantic -Wno-long-long")
#SET(CMAKE_CXX_FLAGS="-g -O0 -Wall -Wextra -Wshadow -Wunused-variable
# -Wunused-parameter -Wunused-function -Wunused -Wno-system-headers
# -Wno-deprecated -Woverloaded-virtual -Wwrite-strings -fprofile-arcs
# -ftest-coverage -Wold-style-cast -Weffc++ -Wconversion")
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unneeded-internal-declaration")
    endif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
endif (NOT CMAKE_CXX_FLAGS)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsigned-char")

# Set build type if not given.
if (NOT CMAKE_BUILD_TYPE)
    # Use debug mode if building in dbg or debug directory.
    get_filename_component(_cmpvar ${CMAKE_BINARY_DIR} NAME)
    if(_cmpvar STREQUAL "dbg" OR _cmpvar STREQUAL "debug")
        set (CMAKE_BUILD_TYPE Debug)
    else()
        if(_cmpvar STREQUAL "cov")
            set (CMAKE_BUILD_TYPE Debug)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0 --coverage")
            set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} --coverage")
        else()
            set (CMAKE_BUILD_TYPE Release)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNDEBUG")
        endif(_cmpvar STREQUAL "cov")
    endif(_cmpvar STREQUAL "dbg" OR _cmpvar STREQUAL "debug")
endif (NOT CMAKE_BUILD_TYPE)

# Detect if the compiler supports C++11 if we want to use it.
if (CXX11)
    check_cxx_compiler_flag(-std=c++11 HAS_CXX11)
    if (HAS_CXX11)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    else()
      if (CASA_BUILD)
        message(FATAL_ERROR "CASA_BUILD requires a c++11 compatible compiler")
      else()
        message(FATAL_ERROR "C++11 build was requested but the compiler does not support -std=c++11")
      endif()
    endif()
endif()

# use faster fortran rules for complex operations, removes restoring complex
# infinities if naive computation results in NAN + NAN * I
#Handling complex multiplication and division with correct treating of complex
#infinities (one element Inf regardless of the other) according to the C is
#complicated.
#E.g. a = NaN + 1e30 i; a * a is not NaN but a complex infinity (-Inf - NaN).
#
#Treating this situation correctly has large performance impact. In GCC's
#implementation it is about 4 times slower than the naive implementation, with
#vectorization enabled the impact is even larger.
#As correct treatment of complex infinities when NaN appear in results is seldom
#accounted for, or not required and most other languages do not have these
#rules, the correct treatmeant can be disabled with the -fcx-fortran-rules flag.
#This changes the semantics to those of the FORTRAN language which is removes
#the need for rescuing the result when NaN appear. Python also follows FORTRAN
#rules.
#Additionally the correct behavior is not implemented in all compilers,
#most notably clang which is the default compiler on MacOS. So turning off
#correct treatment with GCC does not only make our code faster but also behave
#the same on more compilers.
#
#This has measurable impact on e.g. applycal where the cpu performance improves
#by about 20%.
# For one reason or another the check on the compiler flag has no
# effect; it still adds the option which fails for clang.
if (NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    check_cxx_compiler_flag(-fcx-fortran-rules HAS_GXX_FORTRAN_RULES)
    check_c_compiler_flag(-fcx-fortran-rules HAS_GCC_FORTRAN_RULES)
    # added before cmake flags so it can be disabled with
    # -fno-cx-fortran-rules for testing
    if (HAS_GXX_FORTRAN_RULES)
        set(CMAKE_CXX_FLAGS "-fcx-fortran-rules ${CMAKE_CXX_FLAGS}")
    endif()
    if (HAS_GCC_FORTRAN_RULES)
        set(CMAKE_C_FLAGS "-fcx-fortran-rules ${CMAKE_C_FLAGS}")
    endif()
else()
    # Ensure clang is not complaining about unused arguments.
    set(CMAKE_CXX_FLAGS "-Qunused-arguments ${CMAKE_CXX_FLAGS}")    
    set(CMAKE_C_FLAGS "-Qunused-arguments ${CMAKE_C_FLAGS}")    
endif()

# Since 2015, we need pwrite and pwrite (POSIX 2001)
check_function_exists(pread HAVE_PREAD)
check_function_exists(pwrite HAVE_PWRITE)
if (NOT (HAVE_PREAD AND HAVE_PWRITE))
        message(FATAL_ERROR "Casacore requires pread and pwrite functionality" )
endif (NOT (HAVE_PREAD AND HAVE_PWRITE))

# FindHDF5 uses environment variables, so set it if needed.
if (HDF5_ROOT_DIR)
    set (ENV{HDF5_ROOT} ${HDF5_ROOT_DIR})
endif (HDF5_ROOT_DIR)

# Find out which modules to build.
if (NOT MODULE)
   set (MODULE all)
endif (NOT MODULE)
set (_usebison YES)
set (_uselapack YES)
set (_usefits NO)
set (_usewcs NO)
set (_modules casa)
set (_modules2 )
if (NOT ${MODULE} STREQUAL "casa")
    set (_modules ${_modules} tables)
    set (_usebison YES)
    if (NOT ${MODULE} STREQUAL "tables")
        set (_modules ${_modules} scimath_f scimath measures meas)
        set (_uselapack YES)
        if (NOT ${MODULE} STREQUAL "measures")

=== build-tools/CMakeLists.txt ===
#
# CASA build-tools
#

install (PROGRAMS
  casacore_assay
  casacore_floatcheck
  casacore_memcheck
DESTINATION bin
)

install (FILES
  casacore_memcheck.supp
DESTINATION share/casacore
)

=== casa/CMakeLists.txt ===
#
# CASA casa
#

configure_file (
  config.h.in
  "${PROJECT_BINARY_DIR}/casacore/casa/config.h"
  @ONLY)


set (
parser_inputs
JsonGram
)
 
foreach (src ${parser_inputs})
    BISON_TARGET (${src} Json/${src}.yy ${CMAKE_CURRENT_BINARY_DIR}/${src}.ycc COMPILE_FLAGS "-y -p ${src}")
    FLEX_TARGET (${src} Json/${src}.ll ${CMAKE_CURRENT_BINARY_DIR}/${src}.lcc COMPILE_FLAGS "-P${src}")
endforeach (src)

include_directories (${CMAKE_CURRENT_BINARY_DIR})


add_library (casa_casa
Arrays/ArrayBase.cc
Arrays/ArrayError.cc
Arrays/ArrayOpsDiffShapes.cc
Arrays/ArrayPartMath.cc
Arrays/ArrayPosIter.cc
Arrays/ArrayUtil2.cc
Arrays/Array2.cc
Arrays/Array2Math.cc
Arrays/Array_tmpl.cc
Arrays/AxesMapping.cc
Arrays/AxesSpecifier.cc
Arrays/ExtendSpecifier.cc
Arrays/IPosition.cc
Arrays/IPosition2.cc
Arrays/MaskArrMath2.cc
Arrays/Matrix2Math.cc
Arrays/Matrix_tmpl.cc
Arrays/Slice.cc
Arrays/Slicer.cc
Arrays/Vector_tmpl.cc
BasicMath/Math.cc
BasicMath/Primes.cc
BasicMath/Random.cc
BasicSL/Complex.cc
BasicSL/Constants.cc
BasicSL/IComplex.cc
BasicSL/RegexBase.cc
BasicSL/STLMath.cc
BasicSL/String.cc
Containers/Allocator.cc
Containers/Block.cc
Containers/Block_tmpl.cc
Containers/HashMap2.cc
Containers/IterError.cc
Containers/List2.cc
Containers/Map2.cc
Containers/Record.cc
Containers/RecordDesc.cc
Containers/RecordDescRep.cc
Containers/RecordFieldId.cc
Containers/RecordField2Writer.cc
Containers/RecordInterface.cc
Containers/RecordRep.cc
Containers/Record2.cc
Containers/Record2Interface.cc
Containers/StackError.cc
Containers/Stack2.cc
Containers/ValueHolder.cc
Containers/ValueHolderRep.cc
Exceptions/Error2.cc
Exceptions/CasaErrorTools.cc
HDF5/HDF5DataSet.cc
HDF5/HDF5DataType.cc
HDF5/HDF5Error.cc
HDF5/HDF5File.cc
HDF5/HDF5Group.cc
HDF5/HDF5HidMeta.cc
HDF5/HDF5Object.cc
HDF5/HDF5Record.cc
Inputs/Input.cc
Inputs/Param.cc
IO/AipsIO.cc
IO/BaseSinkSource.cc
IO/BucketBase.cc
IO/BucketBuffered.cc
IO/BucketCache.cc
IO/BucketFile.cc
IO/BucketMapped.cc
IO/ByteIO.cc
IO/ByteSink.cc
IO/ByteSinkSource.cc
IO/ByteSource.cc
IO/CanonicalIO.cc
IO/ConversionIO.cc
IO/FilebufIO.cc
IO/FiledesIO.cc
IO/FileLocker.cc
IO/LECanonicalIO.cc
IO/LockFile.cc
IO/MemoryIO.cc
IO/MFFileIO.cc
IO/MMapfdIO.cc
IO/MMapIO.cc
IO/MultiFile.cc
IO/MultiFileBase.cc
IO/MultiHDF5.cc
IO/RawIO.cc
IO/RegularFileIO.cc
IO/StreamIO.cc
IO/TapeIO.cc
IO/TypeIO.cc
Json/JsonError.cc
Json/JsonKVMap.cc
Json/JsonOut.cc
Json/JsonParser.cc
Json/JsonValue.cc
Logging/LogFilter.cc
Logging/LogFilterInterface.cc
Logging/LogIO.cc
Logging/LogMessage.cc
Logging/LogOrigin.cc
Logging/LogSink.cc
Logging/LogSinkInterface.cc
Logging/MemoryLogSink.cc
Logging/NullLogSink.cc
Logging/StreamLogSink.cc
OS/CanonicalConversion.cc
OS/CanonicalDataConversion.cc
OS/Conversion.cc
OS/DataConversion.cc
OS/Directory.cc
OS/DirectoryIterator.cc
OS/DOos.cc
OS/DynLib.cc
OS/EnvVar.cc
OS/File.cc
OS/HostInfo.cc
OS/IBMConversion.cc
OS/IBMDataConversion.cc
OS/MemoryTrace.cc
OS/LECanonicalConversion.cc
OS/LECanonicalDataConversion.cc
OS/LittleEndianConversion.cc
OS/malloc.cc
OS/Memory.cc
OS/MemoryTrace.cc
OS/ModcompConversion.cc
OS/ModcompDataConversion.cc
OS/Mutex.cc
OS/Path.cc
OS/PrecTimer.cc
OS/RawDataConversion.cc
OS/RegularFile.cc
OS/SymLink.cc
OS/Time.cc
OS/Timer.cc
OS/VAXConversion.cc
OS/VAXDataConversion.cc
Quanta/Euler.cc
Quanta/MeasValue.cc
Quanta/MVAngle.cc
Quanta/MVBaseline.cc
Quanta/MVDirection.cc
Quanta/MVDoppler.cc
Quanta/MVDouble.cc
Quanta/MVEarthMagnetic.cc
Quanta/MVEpoch.cc
Quanta/MVFrequency.cc
Quanta/MVPosition.cc
Quanta/MVRadialVelocity.cc
Quanta/MVTime.cc
Quanta/MVuvw.cc
Quanta/QBase.cc
Quanta/QC.cc
Quanta/QLogical2.cc
Quanta/QMath2.cc
Quanta/QuantumHolder.cc
Quanta/Quantum2.cc
Quanta/RotMatrix.cc
Quanta/Unit.cc
Quanta/UnitDim.cc
Quanta/UnitMap.cc
Quanta/UnitMap2.cc
Quanta/UnitMap3.cc
Quanta/UnitMap4.cc
Quanta/UnitMap5.cc
Quanta/UnitMap6.cc
Quanta/UnitMap7.cc
Quanta/UnitName.cc
Quanta/UnitVal.cc
System/Aipsrc.cc
System/AipsrcBool.cc
System/AipsrcValue2.cc
System/AipsrcVBool.cc
System/AipsrcVString.cc
System/AppInfo.cc
System/Casarc.cc
System/Choice.cc
System/ObjectID.cc
System/ObjectID2.cc
System/PGPlotter.cc
System/PGPlotterInterface.cc
System/PGPlotterNull.cc
System/ProgressMeter.cc
Utilities/BitVector.cc
Utilities/CountedPtr2.cc
Utilities/Compare.cc
Utilities/CompositeNumber.cc
Utilities/Copy2.cc
Utilities/cregex.cc
Utilities/DataType.cc
Utilities/DynBuffer.cc
Utilities/Fallible2.cc
Utilities/MUString.cc
Utilities/Notice.cc
Utilities/Precision.cc
Utilities/RecordTransformable.cc
Utilities/Regex.cc
Utilities/RegSequence.cc
Utilities/Sequence2.cc
Utilities/Sort.cc
Utilities/SortError.cc
Utilities/StringDistance.cc
Utilities/ValType.cc
aips.cc
version.cc
${BISON_JsonGram_OUTPUTS}
${FLEX_JsonGram_OUTPUTS}
)

if (HDF5_FOUND)
    list (APPEND de_libraries ${HDF5_LIBRARIES})
endif (HDF5_FOUND)
if (READLINE_FOUND)
    list (APPEND de_libraries ${READLINE_LIBRARIES})
endif (READLINE_FOUND)

target_link_libraries (
casa_casa
${de_libraries}
${libm}
dl
${CASACORE_ARCH_LIBS}
)

add_subdirectory (apps)

install (
TARGETS casa_casa
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Arrays/ArrayAccessor.h
Arrays/ArrayBase.h
Arrays/ArrayError.h
Arrays/Array.h
Arrays/Array.tcc
Arrays/ArrayIO.h
Arrays/ArrayIO.tcc
Arrays/ArrayIter.h
Arrays/ArrayIter.tcc
Arrays/ArrayLogical.h
Arrays/ArrayLogical.tcc
Arrays/ArrayMathBase.h
Arrays/ArrayMath.h
Arrays/ArrayMath.tcc
Arrays/ArrayOpsDiffShapes.h
Arrays/ArrayOpsDiffShapes.tcc
Arrays/ArrayPartMath.h
Arrays/ArrayPartMath.tcc
Arrays/ArrayPosIter.h
Arrays/ArrayUtil.h
Arrays/ArrayUtil.tcc
Arrays/AxesMapping.h
Arrays/AxesSpecifier.h
Arrays/Cube.h
Arrays/Cube.tcc
Arrays/ExtendSpecifier.h
Arrays/IPosition.h
Arrays/LogiArrayFwd.h
Arrays/LogiArray.h
Arrays/LogiCube.h
Arrays/LogiMatrix.h
Arrays/LogiVector.h
Arrays/MaskArrIO.h
Arrays/MaskArrIO.tcc
Arrays/MaskArrLogi.h
Arrays/MaskArrLogi.tcc
Arrays/MaskArrMath.h
Arrays/MaskArrMath.tcc
Arrays/MaskedArray.h
Arrays/MaskedArray.tcc
Arrays/MaskLogiArrFwd.h
Arrays/MaskLogiArr.h
Arrays/Matrix.h
Arrays/Matrix.tcc
Arrays/MatrixIter.h
Arrays/MatrixIter.tcc
Arrays/MatrixMath.h
Arrays/MatrixMath.tcc
Arrays/Slice.h
Arrays/Slicer.h
Arrays/Vector.h
Arrays/Vector.tcc
Arrays/Vector2.tcc
Arrays/VectorIter.h
Arrays/VectorIter.tcc
Arrays/VectorSTLIterator.h
DESTINATION include/casacore/casa/Arrays
)

install (FILES
BasicMath/ConvertScalar.h
BasicMath/Functional.h
BasicMath/Functional.tcc
BasicMath/Functors.h
BasicMath/Math.h
BasicMath/Primes.h
BasicMath/Random.h
BasicMath/StdLogical.h
DESTINATION include/casacore/casa/BasicMath
)

install (FILES
BasicSL/Complexfwd.h
BasicSL/Complex.h
BasicSL/Constants.h
BasicSL/IComplex.h
BasicSL/RegexBase.h
BasicSL/String.h
BasicSL/STLMath.h
BasicSL/STLIO.h
BasicSL/STLIO.tcc
DESTINATION include/casacore/casa/BasicSL
)

install (FILES
Containers/Allocator.h
Containers/Block.h
Containers/BlockIO.h
Containers/BlockIO.tcc
Containers/ContainerIO.h
Containers/HashMap.h
Containers/HashMap.tcc
Containers/HashMapIO.h
Containers/HashMapIO.tcc
Containers/HashMapIter.h
Containers/HashMapIter.tcc
Containers/IterError.h
Containers/Link.h
Containers/Link.tcc
Containers/List.h
Containers/List.tcc
Containers/ListIO.h
Containers/ListIO.tcc
Containers/Map.h
Containers/Map.tcc
Containers/MapIO.h
Containers/MapIO.tcc
Containers/ObjectPool.h
Containers/ObjectPool.tcc
Containers/ObjectStack.h
Containers/ObjectStack.tcc
Containers/OrderedMap.h
Containers/OrderedMap.tcc
Containers/OrderedPair.h
Containers/OrderedPair.tcc
Containers/OrdMapIO.h
Containers/OrdMapIO.tcc
Containers/OrdPairIO.h
Containers/OrdPairIO.tcc
Containers/PoolStack.h
Containers/PoolStack.tcc
Containers/Queue.h
Containers/Queue.tcc
Containers/RecordDesc.h
Containers/RecordDescRep.h
Containers/RecordField.h
Containers/RecordField.tcc
Containers/RecordFieldId.h
Containers/RecordFieldWriter.h
Containers/RecordFieldWriter.tcc
Containers/Record.h
Containers/RecordInterface.h
Containers/RecordRep.h
Containers/SimOrdMap.h
Containers/SimOrdMap.tcc
Containers/SimOrdMapIO.h
Containers/SimOrdMapIO.tcc
Containers/StackError.h
Containers/Stack.h
Containers/Stack.tcc
Containers/ValueHolder.h
Containers/ValueHolderRep.h
DESTINATION include/casacore/casa/Containers
)

install (FILES
Exceptions/CasaErrorTools.h
Exceptions/Error.h
Exceptions/Error.tcc
DESTINATION include/casacore/casa/Exceptions
)

install (FILES
HDF5/HDF5DataSet.h
HDF5/HDF5DataType.h
HDF5/HDF5Error.h
HDF5/HDF5File.h
HDF5/HDF5Group.h
HDF5/HDF5HidMeta.h
HDF5/HDF5Object.h
HDF5/HDF5Record.h
DESTINATION include/casacore/casa/HDF5
)

install (FILES
Inputs/Input.h
Inputs/Param.h
DESTINATION include/casacore/casa/Inputs
)

install (FILES
IO/AipsIOCarray.h
IO/AipsIOCarray.tcc
IO/AipsIO.h
IO/BaseSinkSource.h
IO/BucketBase.h
IO/BucketBuffered.h
IO/BucketCache.h
IO/BucketFile.h
IO/BucketMapped.h
IO/ByteIO.h
IO/ByteSink.h
IO/ByteSinkSource.h
IO/ByteSource.h
IO/CanonicalIO.h
IO/ConversionIO.h
IO/FilebufIO.h
IO/FiledesIO.h
IO/FileLocker.h
IO/LargeFilebufIO.h
IO/LargeFiledesIO.h
IO/LargeIOFuncDef.h
IO/LargeRegularFileIO.h
IO/LECanonicalIO.h
IO/LockFile.h
IO/MemoryIO.h
IO/MFFileIO.h
IO/MMapfdIO.h
IO/MMapIO.h
IO/MultiFile.h
IO/MultiFileBase.h
IO/MultiHDF5.h
IO/RawIO.h
IO/RegularFileIO.h
IO/StreamIO.h
IO/TapeIO.h
IO/TypeIO.h
DESTINATION include/casacore/casa/IO
)

install (FILES
Json/JsonError.h
Json/JsonKVMap.h
Json/JsonOut.h
Json/JsonOut.tcc
Json/JsonParser.h
Json/JsonValue.h
DESTINATION include/casacore/casa/Json
)

install (FILES
Logging/LogFilter.h
Logging/LogFilterInterface.h
Logging/LogIO.h
Logging/LogMessage.h
Logging/LogOrigin.h
Logging/LogSink.h
Logging/LogSinkInterface.h
Logging/MemoryLogSink.h
Logging/NullLogSink.h
Logging/StreamLogSink.h
DESTINATION include/casacore/casa/Logging
)

install (FILES
OS/CanonicalConversion.h
OS/CanonicalDataConversion.h
OS/Conversion.h
OS/DataConversion.h
OS/Directory.h
OS/DirectoryIterator.h
OS/DOos.h
OS/DynLib.h
OS/EnvVar.h
OS/File.h
OS/HostInfoBsd.h
OS/HostInfoDarwin.h
OS/HostInfo.h
OS/HostInfoHpux.h
OS/HostInfoIrix.h
OS/HostInfoLinux.h
OS/HostInfoOsf1.h
OS/HostInfoSolaris.h
OS/IBMConversion.h
OS/IBMDataConversion.h
OS/LECanonicalConversion.h
OS/LECanonicalDataConversion.h
OS/LittleEndianConversion.h
OS/malloc.h
OS/Memory.h
OS/MemoryTrace.h
OS/ModcompConversion.h
OS/ModcompDataConversion.h
OS/Mutex.h
OS/Path.h
OS/PrecTimer.h
OS/RawDataConversion.h
OS/RegularFile.h
OS/SymLink.h
OS/Time.h
OS/Timer.h
OS/VAXConversion.h
OS/VAXDataConversion.h
DESTINATION include/casacore/casa/OS
)

install (FILES
Quanta/Euler.h
Quanta/MeasValue.h
Quanta/MVAngle.h
Quanta/MVBaseline.h
Quanta/MVDirection.h
Quanta/MVDoppler.h
Quanta/MVDouble.h
Quanta/MVEarthMagnetic.h
Quanta/MVEpoch.h
Quanta/MVFrequency.h
Quanta/MVPosition.h
Quanta/MVRadialVelocity.h
Quanta/MVTime.h
Quanta/MVuvw.h
Quanta/QBase.h
Quanta/QC.h
Quanta/QLogical.h
Quanta/QLogical.tcc
Quanta/QMath.h
Quanta/QMath.tcc
Quanta/Quantum.h
Quanta/Quantum.tcc
Quanta/QVector.h
Quanta/QVector.tcc
Quanta/QuantumHolder.h
Quanta/QuantumType.h
Quanta/RotMatrix.h
Quanta/UnitDim.h
Quanta/Unit.h
Quanta/UnitMap.h
Quanta/UnitName.h
Quanta/UnitVal.h
DESTINATION include/casacore/casa/Quanta
)

install (FILES
System/Aipsrc.h
System/AipsrcValue.h
System/AipsrcValue.tcc
System/AipsrcVector.h
System/AipsrcVector.tcc
System/AppInfo.h
System/Casarc.h
System/Choice.h
System/ObjectID.h
System/PGPlotter.h
System/PGPlotterInterface.h
System/PGPlotterNull.h
System/ProgressMeter.h
DESTINATION include/casacore/casa/System
)

install (FILES
Utilities/Assert.h
Utilities/Assert.tcc
Utilities/BinarySearch.h
Utilities/BinarySearch.tcc
Utilities/BitVector.h
Utilities/CASATask.h
Utilities/Compare.h
Utilities/Compare.tcc
Utilities/CompositeNumber.h
Utilities/Copy.h
Utilities/Copy.tcc
Utilities/CountedPtr.h
Utilities/CountedPtr.tcc
Utilities/COWPtr.h
Utilities/COWPtr.tcc
Utilities/cregex.h
Utilities/DataType.h
Utilities/DefaultValue.h
Utilities/DynBuffer.h
Utilities/Fallible.h
Utilities/generic.h
Utilities/GenSort.h

=== coordinates/CMakeLists.txt ===
#
# CASA coordinates
#

add_library (casa_coordinates
Coordinates/Coordinate.cc
Coordinates/CoordinateSystem.cc
Coordinates/CoordinateUtil.cc
Coordinates/Direction2Coordinate.cc
Coordinates/DirectionCoordinate.cc
Coordinates/FITSCoordinateUtil.cc
Coordinates/GaussianConvert.cc
Coordinates/LinearCoordinate.cc
Coordinates/LinearXform2.cc
Coordinates/LinearXform.cc
Coordinates/ObsInfo.cc
Coordinates/Projection.cc
Coordinates/Spectral2Coordinate.cc
Coordinates/SpectralCoordinate.cc
Coordinates/QualityCoordinate.cc
Coordinates/StokesCoordinate.cc
Coordinates/TabularCoordinate.cc
)

target_link_libraries (casa_coordinates casa_fits ${WCSLIB_LIBRARIES} ${CASACORE_ARCH_LIBS})

install (TARGETS casa_coordinates
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Coordinates/DirectionCoordinate.h
Coordinates/LinearXform.h
Coordinates/SpectralCoordinate.h
Coordinates/Coordinate.h
Coordinates/StokesCoordinate.h
Coordinates/QualityCoordinate.h
Coordinates/FITSCoordinateUtil.h
Coordinates/CoordinateSystem.h
Coordinates/FrequencyAligner.h
Coordinates/FrequencyAligner.tcc
Coordinates/Projection.h
Coordinates/ObsInfo.h
Coordinates/CoordinateUtil.h
Coordinates/GaussianConvert.h
Coordinates/LinearCoordinate.h
Coordinates/TabularCoordinate.h
DESTINATION include/casacore/coordinates/Coordinates
)

install (FILES
Coordinates.h
DESTINATION include/casacore/coordinates
)

add_subdirectory (Coordinates/test ${EXCL_ALL})

=== images/CMakeLists.txt ===
#
# CASA Images
#

BISON_TARGET (ImageExprGram Images/ImageExprGram.yy ${CMAKE_CURRENT_BINARY_DIR}/ImageExprGram.ycc COMPILE_FLAGS "-p ImageExprGram")
FLEX_TARGET (ImageExprGram Images/ImageExprGram.ll ${CMAKE_CURRENT_BINARY_DIR}/ImageExprGram.lcc COMPILE_FLAGS "-PImageExprGram")

include_directories (${CMAKE_CURRENT_BINARY_DIR})

add_library (casa_images
Regions/WCEllipsoid.cc
Regions/RegionManager.cc
Regions/WCLELMask.cc
Regions/WCPolygon.cc
Regions/WCUnion.cc
Regions/WCRegion2.cc
Regions/RegionHandlerMemory.cc
Regions/WCExtension.cc
Regions/RegionHandlerTable.cc
Regions/WCCompound.cc
Regions/WCRegion.cc
Regions/WCIntersection.cc
Regions/WCConcatenation.cc
Regions/ImageRegion.cc
Regions/RFReaderWriter.cc
Regions/RegionHandler.cc
Regions/WCDifference.cc
Regions/WCBox.cc
Regions/AipsIOReaderWriter.cc
Regions/WCComplement.cc
Regions/RegionHandlerHDF5.cc
Images/FITSErrorImage.cc
Images/FITSImage.cc
Images/FITSImgParser.cc
Images/FITSQualityImage.cc
Images/FITSQualityMask.cc
Images/HDF5Image2.cc
Images/Image_tmpl.cc
Images/ImageAttrGroup.cc
Images/ImageAttrGroupCasa.cc
Images/ImageAttrGroupHDF5.cc
Images/ImageAttrHandler.cc
Images/ImageAttrHandlerCasa.cc
Images/ImageAttrHandlerHDF5.cc
Images/ImageBeamSet.cc
Images/ImageExprGram.cc
Images/ImageExprParse.cc
Images/ImageFITS2Converter.cc
Images/ImageInfo.cc
Images/ImageOpener.cc
Images/ImageProxy.cc
Images/ImageUtilities.cc
Images/LELImageCoord.cc
Images/MIRIADImage.cc
Images/MaskSpecifier.cc
Images/PagedImage2.cc
${BISON_ImageExprGram_OUTPUTS}
${FLEX_ImageExprGram_OUTPUTS}
)

target_link_libraries (
casa_images
casa_coordinates
casa_mirlib
casa_lattices
${CASACORE_ARCH_LIBS}
)

add_subdirectory (apps)

install (
TARGETS casa_images
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Images/CurvedImage2D.h
Images/CurvedImage2D.tcc
Images/ExtendImage.h
Images/ExtendImage.tcc
Images/FITS2Image.tcc
Images/FITSErrorImage.h
Images/FITSImage.h
Images/FITSImgParser.h
Images/FITSQualityImage.h
Images/FITSQualityMask.h
Images/HDF5Image.h
Images/HDF5Image.tcc
Images/ImageAttrGroup.h
Images/ImageAttrGroupCasa.h
Images/ImageAttrGroupHDF5.h
Images/ImageAttrHandler.h
Images/ImageAttrHandlerCasa.h
Images/ImageAttrHandlerHDF5.h
Images/ImageBeamSet.h
Images/ImageConcat.h
Images/ImageConcat.tcc
Images/ImageExpr.h
Images/ImageExpr.tcc
Images/ImageExprGram.h
Images/ImageExprParse.h
Images/ImageFITSConverter.h
Images/ImageFITSConverter.tcc
Images/ImageInfo.h
Images/ImageInterface.h
Images/ImageInterface.tcc
Images/ImageOpener.h
Images/ImageProxy.h
Images/ImageRegrid.h
Images/ImageRegrid.tcc
Images/ImageStatistics.h
Images/ImageStatistics.tcc
Images/ImageSummary.h
Images/ImageSummary.tcc
Images/ImageUtilities.h
Images/ImageUtilities2.tcc
Images/LELImageCoord.h
Images/MIRIADImage.h
Images/MaskSpecifier.h
Images/PagedImage.h
Images/PagedImage.tcc
Images/RebinImage.h
Images/RebinImage.tcc
Images/SubImage.h
Images/SubImage.tcc
Images/TempImage.h
Images/TempImage.tcc
Images/WCBox.h
DESTINATION include/casacore/images/Images
)

install (FILES
Regions/AipsIOReaderWriter.h
Regions/ImageRegion.h
Regions/RegionHandler.h
Regions/RegionHandlerHDF5.h
Regions/RegionHandlerMemory.h
Regions/RegionHandlerTable.h
Regions/RegionManager.h
Regions/RFReaderWriter.h
Regions/WCBox.h
Regions/WCComplement.h
Regions/WCCompound.h
Regions/WCConcatenation.h
Regions/WCDifference.h
Regions/WCEllipsoid.h
Regions/WCExtension.h
Regions/WCIntersection.h
Regions/WCLELMask.h
Regions/WCPolygon.h
Regions/WCRegion.h
Regions/WCUnion.h
DESTINATION include/casacore/images/Regions
)

# Temporary hack until all packages use scimath/GaussianBeam
install (FILES
Images/GaussianBeam.h
DESTINATION include/casacore/components/ComponentModels
)

install (FILES
Regions.h
Images.h
DESTINATION include/casacore/images
)

add_subdirectory (Images/test ${EXCL_ALL})
add_subdirectory (Regions/test ${EXCL_ALL})

=== lattices/CMakeLists.txt ===
#
# CASA Lattices
#

add_library (casa_lattices
Lattices/Lattices_tmpl.cc
Lattices/LatticeBase.cc
Lattices/LatticeIndexer.cc
Lattices/LatticeLocker.cc
Lattices/LatticeNavigator.cc
Lattices/LatticeStepper.cc
Lattices/PixelCurve1D.cc
Lattices/TileStepper.cc
Lattices/TiledLineStepper.cc
Lattices/TiledShape.cc
LatticeMath/Fit2D.cc
LatticeMath/LatticeAddNoise.cc
LatticeMath/LatticeCleanProgress.cc
LatticeMath/LatticeFFT.cc
LatticeMath/LatticeFit.cc
LatticeMath/LatticeHistProgress.cc
LatticeMath/LatticeHistSpecialize.cc
LatticeMath/LatticeProgress.cc
LatticeMath/LatticeStatsBase.cc
LatticeMath/LattStatsProgress.cc
LatticeMath/LattStatsSpecialize.cc
LEL/LatticeExprNode.cc
LEL/LELArrayBase.cc
LEL/LELAttribute.cc
LEL/LELBinary2.cc
LEL/LELCoordinates.cc
LEL/LELFunction2.cc
LEL/LELLattCoord.cc
LEL/LELLattCoordBase.cc
LEL/LELRegion.cc
LEL/LELUnary2.cc
LRegions/FITSMask.cc
LRegions/LatticeRegion.cc
LRegions/LattRegionHolder.cc
LRegions/LCBox.cc
LRegions/LCComplement.cc
LRegions/LCConcatenation.cc
LRegions/LCDifference.cc
LRegions/LCEllipsoid.cc
LRegions/LCExtension.cc
LRegions/LCHDF5Mask.cc
LRegions/LCIntersection.cc
LRegions/LCLELMask.cc
LRegions/LCMask.cc
LRegions/LCPagedMask.cc
LRegions/LCPixelSet.cc
LRegions/LCPolygon.cc
LRegions/LCRegion.cc
LRegions/LCRegion2.cc
LRegions/LCRegionFixed.cc
LRegions/LCRegionMulti.cc
LRegions/LCRegionSingle.cc
LRegions/LCSlicer.cc
LRegions/LCStretch.cc
LRegions/LCUnion.cc
LRegions/RegionType.cc
)

target_link_libraries (
casa_lattices
casa_tables
casa_scimath
${CASACORE_ARCH_LIBS}
)

install (TARGETS casa_lattices
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Lattices/ArrayLattice.h
Lattices/ArrayLattice.tcc
Lattices/CurvedLattice2D.h
Lattices/CurvedLattice2D.tcc
Lattices/ExtendLattice.h
Lattices/ExtendLattice.tcc
Lattices/HDF5LattIter.h
Lattices/HDF5LattIter.tcc
Lattices/HDF5Lattice.h
Lattices/HDF5Lattice.tcc
Lattices/Lattice.h
Lattices/Lattice.tcc
Lattices/LatticeBase.h
Lattices/LatticeCache.h
Lattices/LatticeCache.tcc
Lattices/LatticeConcat.h
Lattices/LatticeConcat.tcc
Lattices/LatticeIndexer.h
Lattices/LatticeIterInterface.h
Lattices/LatticeIterInterface.tcc
Lattices/LatticeIterator.h
Lattices/LatticeIterator.tcc
Lattices/LatticeLocker.h
Lattices/LatticeNavigator.h
Lattices/LatticeStepper.h
Lattices/LatticeUtilities.h
Lattices/LatticeUtilities.tcc
Lattices/MaskedLattice.h
Lattices/MaskedLattice.tcc
Lattices/MaskedLatticeIterator.h
Lattices/MaskedLatticeIterator.tcc
Lattices/PagedArrIter.h
Lattices/PagedArrIter.tcc
Lattices/PagedArray.h
Lattices/PagedArray.tcc
Lattices/PixelCurve1D.h
Lattices/RebinLattice.h
Lattices/RebinLattice.tcc
Lattices/SubLattice.h
Lattices/SubLattice.tcc
Lattices/TempLattice.h
Lattices/TempLattice.tcc
Lattices/TempLatticeImpl.h
Lattices/TempLatticeImpl.tcc
Lattices/TileStepper.h
Lattices/TiledLineStepper.h
Lattices/TiledShape.h
DESTINATION include/casacore/lattices/Lattices
)

install (FILES
LatticeMath/StatsTiledCollapser.h
LatticeMath/StatsTiledCollapser.tcc
LatticeMath/CLIPNearest2D.h
LatticeMath/CLIPNearest2D.tcc
LatticeMath/CLInterpolator2D.h
LatticeMath/CLInterpolator2D.tcc
LatticeMath/Fit2D.h
LatticeMath/LatticeAddNoise.h
LatticeMath/LatticeApply.h
LatticeMath/LatticeApply.tcc
LatticeMath/LatticeCleanProgress.h
LatticeMath/LatticeCleaner.h
LatticeMath/LatticeCleaner.tcc
LatticeMath/LatticeConvolver.h
LatticeMath/LatticeConvolver.tcc
LatticeMath/LatticeFFT.h
LatticeMath/LatticeFit.h
LatticeMath/LatticeFractile.h
LatticeMath/LatticeFractile.tcc
LatticeMath/LatticeHistProgress.h
LatticeMath/LatticeHistSpecialize.h
LatticeMath/LatticeHistograms.h
LatticeMath/LatticeHistograms.tcc
LatticeMath/LatticeMathUtil.h
LatticeMath/LatticeMathUtil.tcc
LatticeMath/LatticeProgress.h
LatticeMath/LatticeSlice1D.h
LatticeMath/LatticeSlice1D.tcc
LatticeMath/LatticeStatistics.h
LatticeMath/LatticeStatistics.tcc
LatticeMath/LatticeStatsBase.h
LatticeMath/LatticeStatsDataProvider.h
LatticeMath/LatticeStatsDataProvider.tcc
LatticeMath/LatticeStatsDataProviderBase.h
LatticeMath/LatticeStatsDataProviderBase.tcc
LatticeMath/LatticeTwoPtCorr.h
LatticeMath/LatticeTwoPtCorr.tcc
LatticeMath/LattStatsProgress.h
LatticeMath/LattStatsSpecialize.h
LatticeMath/LineCollapser.h
LatticeMath/LineCollapser.tcc
LatticeMath/MaskedLatticeStatsDataProvider.h
LatticeMath/MaskedLatticeStatsDataProvider.tcc
LatticeMath/MultiTermLatticeCleaner.h
LatticeMath/MultiTermLatticeCleaner.tcc
LatticeMath/TiledCollapser.h
LatticeMath/TiledCollapser.tcc
DESTINATION include/casacore/lattices/LatticeMath
)

install (FILES
LEL/LatticeExpr.h
LEL/LatticeExpr.tcc
LEL/LatticeExprNode.h
LEL/LELArray.h
LEL/LELArray.tcc
LEL/LELArrayBase.h
LEL/LELAttribute.h
LEL/LELBinary.h
LEL/LELBinary.tcc
LEL/LELBinary2.h
LEL/LELBinaryEnums.h
LEL/LELCondition.h
LEL/LELCondition.tcc
LEL/LELConvert.h
LEL/LELConvert.tcc
LEL/LELCoordinates.h
LEL/LELFunction.h
LEL/LELFunction.tcc
LEL/LELFunction2.h
LEL/LELFunctionEnums.h
LEL/LELInterface.h
LEL/LELInterface.tcc
LEL/LELLattCoord.h
LEL/LELLattCoordBase.h
LEL/LELLattice.h
LEL/LELLattice.tcc
LEL/LELRegion.h
LEL/LELScalar.h
LEL/LELScalar.tcc
LEL/LELSpectralIndex.h
LEL/LELSpectralIndex.tcc
LEL/LELUnary.h
LEL/LELUnary.tcc
LEL/LELUnary2.h
LEL/LELUnaryEnums.h
DESTINATION include/casacore/lattices/LEL
)

install (FILES
LRegions/FITSMask.h
LRegions/LatticeRegion.h
LRegions/LattRegionHolder.h
LRegions/LCBox.h
LRegions/LCComplement.h
LRegions/LCConcatenation.h
LRegions/LCDifference.h
LRegions/LCEllipsoid.h
LRegions/LCExtension.h
LRegions/LCHDF5Mask.h
LRegions/LCIntersection.h
LRegions/LCLELMask.h
LRegions/LCMask.h
LRegions/LCPagedMask.h
LRegions/LCPixelSet.h
LRegions/LCPolygon.h
LRegions/LCRegion.h
LRegions/LCRegionFixed.h
LRegions/LCRegionMulti.h
LRegions/LCRegionSingle.h
LRegions/LCSlicer.h
LRegions/LCStretch.h
LRegions/LCUnion.h
LRegions/RegionType.h
DESTINATION include/casacore/lattices/LRegions
)

install (FILES
LatticeMath.h
Lattices.h
LEL.h
LRegions.h
DESTINATION include/casacore/lattices
)

# The tests
add_subdirectory (Lattices/test ${EXCL_ALL})
add_subdirectory (LatticeMath/test ${EXCL_ALL})
add_subdirectory (LEL/test ${EXCL_ALL})
add_subdirectory (LRegions/test ${EXCL_ALL})

=== meas/CMakeLists.txt ===
#
# CASA meas
#

add_library (casa_meas
MeasUDF/PositionEngine.cc
MeasUDF/PositionUDF.cc
MeasUDF/EpochEngine.cc
MeasUDF/EpochUDF.cc
MeasUDF/DirectionUDF.cc
MeasUDF/DirectionEngine.cc
MeasUDF/Register.cc
)

target_link_libraries (casa_meas casa_measures ${CASACORE_ARCH_LIBS})

install (TARGETS casa_meas
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
MeasUDF/PositionUDF.h
MeasUDF/PositionEngine.h
MeasUDF/EpochUDF.h
MeasUDF/EpochEngine.h
MeasUDF/DirectionUDF.h
MeasUDF/DirectionEngine.h
MeasUDF/Register.h
DESTINATION include/casacore/meas/MeasUDF
)

install (FILES
MeasUDF.h
DESTINATION include/casacore/meas
)

add_subdirectory (MeasUDF/test ${EXCL_ALL})

=== ms/CMakeLists.txt ===
#
# CASA MeasurementSets 
#

set (
parser_inputs
MSAntennaGram
MSArrayGram
MSCorrGram
MSFeedGram
MSFieldGram
MSObservationGram
MSScanGram
MSSpwGram
MSTimeGram
MSUvDistGram
MSStateGram
)

foreach (src ${parser_inputs})
    BISON_TARGET (${src} MSSel/${src}.yy ${CMAKE_CURRENT_BINARY_DIR}/${src}.ycc COMPILE_FLAGS "-y -p ${src} --output-file=${src}.ycc")
    FLEX_TARGET (${src} MSSel/${src}.ll ${CMAKE_CURRENT_BINARY_DIR}/${src}.lcc COMPILE_FLAGS "-P${src}")
endforeach (src)

include_directories (${CMAKE_CURRENT_BINARY_DIR})

add_library (casa_ms
MeasurementSets/MSFreqOffset.cc
MeasurementSets/MSProcessorColumns.cc
MeasurementSets/MSHistory.cc
MeasurementSets/MSHistoryHandler.cc
MeasurementSets/MSSource.cc
MeasurementSets/MSFlagCmd.cc
MeasurementSets/MSPolColumns.cc
MeasurementSets/MSSysCal.cc
MeasurementSets/MSState.cc
MeasurementSets/MSTable2.cc
MeasurementSets/MSWeatherColumns.cc
MeasurementSets/MSDopplerUtil.cc
MeasurementSets/MSPointingColumns.cc
MeasurementSets/MSAntenna.cc
MeasurementSets/MSWeather.cc
MeasurementSets/MSTableImpl.cc
MeasurementSets/MSDopplerColumns.cc
MeasurementSets/MSFeedColumns.cc
MeasurementSets/MSField.cc
MeasurementSets/MSAntennaColumns.cc
MeasurementSets/MSObsColumns.cc
MeasurementSets/MSFeed.cc
MeasurementSets/MSColumns.cc
MeasurementSets/MSObservation.cc
MeasurementSets/MSDataDescColumns.cc
MeasurementSets/MSStateColumns.cc
MeasurementSets/MSFlagCmdColumns.cc
MeasurementSets/MeasurementSet.cc
MeasurementSets/MSMainColumns.cc
MeasurementSets/MSSourceColumns.cc
MeasurementSets/MSProcessor.cc
MeasurementSets/MSHistoryColumns.cc
MeasurementSets/MSPointing.cc
MeasurementSets/MSRange.cc
MeasurementSets/MSSysCalColumns.cc
MeasurementSets/MSDoppler.cc
MeasurementSets/StokesConverter.cc
MeasurementSets/MSDataDescription.cc
MeasurementSets/MSTileLayout.cc
MeasurementSets/MSFreqOffColumns.cc
MeasurementSets/MSFieldColumns.cc
MeasurementSets/MSSpectralWindow.cc
MeasurementSets/MSPolarization.cc
MeasurementSets/MSSpWindowColumns.cc
MeasurementSets/MSIter.cc
MeasurementSets/MSTable.cc
MSSel/MSAntennaGram.cc
MSSel/MSAntennaIndex.cc
MSSel/MSAntennaParse.cc
MSSel/MSArrayGram.cc
MSSel/MSArrayParse.cc
MSSel/MSCorrGram.cc
MSSel/MSCorrParse.cc
MSSel/MSDataDescIndex.cc
MSSel/MSDopplerIndex.cc
MSSel/MSFeedGram.cc
MSSel/MSFeedIndex.cc
MSSel/MSFeedParse.cc
MSSel/MSFieldGram.cc
MSSel/MSFieldIndex.cc
MSSel/MSFieldParse.cc
MSSel/MSFreqOffIndex.cc
MSSel/MSObservationGram.cc
MSSel/MSObservationParse.cc
MSSel/MSObsIndex.cc
MSSel/MSParse.cc
MSSel/MSPointingIndex.cc
MSSel/MSPolIndex.cc
MSSel/MSPolnGram.cc
MSSel/MSPolnParse.cc
MSSel/MSScanGram.cc
MSSel/MSScanParse.cc
MSSel/MSSelectableTable.cc
MSSel/MSSelection.cc
MSSel/MSSelectionError.cc
MSSel/MSSelectionErrorHandler.cc
MSSel/MSSSpwErrorHandler.cc
MSSel/MSSelectionKeywords.cc
MSSel/MSSelectionTools.cc
MSSel/MSSelector.cc
MSSel/MSSourceIndex.cc
MSSel/MSSpwGram.cc
MSSel/MSSpwIndex.cc
MSSel/MSSpWindowIndex.cc
MSSel/MSSpwParse.cc
MSSel/MSStateGram.cc
MSSel/MSStateIndex.cc
MSSel/MSStateParse.cc
MSSel/MSSysCalIndex.cc
MSSel/MSTableIndex.cc
MSSel/MSTimeGram.cc
MSSel/MSTimeParse.cc
MSSel/MSUvDistGram.cc
MSSel/MSUvDistParse.cc
MSSel/MSWeatherIndex.cc
MSOper/MS1ToMS2Converter.cc
MSOper/MSConcat.cc
MSOper/MSDerivedValues.cc
MSOper/MSFlagger.cc
MSOper/MSKeys.cc
MSOper/MSLister.cc
MSOper/MSMetaData.cc
MSOper/MSReader.cc
MSOper/MSSummary.cc
MSOper/MSValidIds.cc
MSOper/NewMSSimulator.cc
${BISON_MSAntennaGram_OUTPUTS}
${FLEX_MSAntennaGram_OUTPUTS}
${BISON_MSArrayGram_OUTPUTS}
${FLEX_MSArrayGram_OUTPUTS}
${BISON_MSCorrGram_OUTPUTS}
${FLEX_MSCorrGram_OUTPUTS}
${BISON_MSFeedGram_OUTPUTS}
${FLEX_MSFeedGram_OUTPUTS}
${BISON_MSFieldGram_OUTPUTS}
${FLEX_MSFieldGram_OUTPUTS}
${BISON_MSScanGram_OUTPUTS}
${FLEX_MSScanGram_OUTPUTS}
${BISON_MSObservationGram_OUTPUTS}
${FLEX_MSObservationGram_OUTPUTS}
${BISON_MSSpwGram_OUTPUTS}
${FLEX_MSSpwGram_OUTPUTS}
${BISON_MSTimeGram_OUTPUTS}
${FLEX_MSTimeGram_OUTPUTS}
${BISON_MSUvDistGram_OUTPUTS}
${FLEX_MSUvDistGram_OUTPUTS}
${BISON_MSStateGram_OUTPUTS}
${FLEX_MSStateGram_OUTPUTS}
)

target_link_libraries (
casa_ms casa_measures
${CASACORE_ARCH_LIBS}
)

add_subdirectory (apps)

install (TARGETS casa_ms
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
MeasurementSets/MSAntenna.h
MeasurementSets/MSAntennaColumns.h
MeasurementSets/MSAntennaEnums.h
MeasurementSets/MSColumns.h
MeasurementSets/MSDataDescColumns.h
MeasurementSets/MSDataDescEnums.h
MeasurementSets/MSDataDescription.h
MeasurementSets/MSDoppler.h
MeasurementSets/MSDopplerColumns.h
MeasurementSets/MSDopplerEnums.h
MeasurementSets/MSDopplerUtil.h
MeasurementSets/MSFeed.h
MeasurementSets/MSFeedColumns.h
MeasurementSets/MSFeedEnums.h
MeasurementSets/MSField.h
MeasurementSets/MSFieldColumns.h
MeasurementSets/MSFieldEnums.h
MeasurementSets/MSFlagCmd.h
MeasurementSets/MSFlagCmdColumns.h
MeasurementSets/MSFlagCmdEnums.h
MeasurementSets/MSFreqOffColumns.h
MeasurementSets/MSFreqOffEnums.h
MeasurementSets/MSFreqOffset.h
MeasurementSets/MSHistory.h
MeasurementSets/MSHistoryColumns.h
MeasurementSets/MSHistoryEnums.h
MeasurementSets/MSHistoryHandler.h
MeasurementSets/MSIter.h
MeasurementSets/MSMainColumns.h
MeasurementSets/MSMainEnums.h
MeasurementSets/MSObsColumns.h
MeasurementSets/MSObsEnums.h
MeasurementSets/MSObservation.h
MeasurementSets/MSPointing.h
MeasurementSets/MSPointingColumns.h
MeasurementSets/MSPointingEnums.h
MeasurementSets/MSPolColumns.h
MeasurementSets/MSPolEnums.h
MeasurementSets/MSPolarization.h
MeasurementSets/MSProcessor.h
MeasurementSets/MSProcessorColumns.h
MeasurementSets/MSProcessorEnums.h
MeasurementSets/MSRange.h
MeasurementSets/MSSource.h
MeasurementSets/MSSourceColumns.h
MeasurementSets/MSSourceEnums.h
MeasurementSets/MSSpWindowColumns.h
MeasurementSets/MSSpWindowEnums.h
MeasurementSets/MSSpectralWindow.h
MeasurementSets/MSState.h
MeasurementSets/MSStateColumns.h
MeasurementSets/MSStateEnums.h
MeasurementSets/MSSysCal.h
MeasurementSets/MSSysCalColumns.h
MeasurementSets/MSSysCalEnums.h
MeasurementSets/MSTable.h
MeasurementSets/MSTable.tcc
MeasurementSets/MSTableImpl.h
MeasurementSets/MSTileLayout.h
MeasurementSets/MSWeather.h
MeasurementSets/MSWeatherColumns.h
MeasurementSets/MSWeatherEnums.h
MeasurementSets/MeasurementSet.h
MeasurementSets/StokesConverter.h
DESTINATION include/casacore/ms/MeasurementSets
)

install (FILES
MSSel/MSAntennaGram.h
MSSel/MSAntennaIndex.h
MSSel/MSAntennaParse.h
MSSel/MSArrayGram.h
MSSel/MSArrayParse.h
MSSel/MSCorrGram.h
MSSel/MSCorrParse.h
MSSel/MSDataDescIndex.h
MSSel/MSDopplerIndex.h
MSSel/MSFeedIndex.h
MSSel/MSFieldGram.h
MSSel/MSFieldIndex.h
MSSel/MSFieldParse.h
MSSel/MSFreqOffIndex.h
MSSel/MSObservationGram.h
MSSel/MSObservationParse.h
MSSel/MSObsIndex.h
MSSel/MSParse.h
MSSel/MSPointingIndex.h
MSSel/MSPolIndex.h
MSSel/MSPolnGram.h
MSSel/MSPolnParse.h
MSSel/MSScanGram.h
MSSel/MSScanParse.h
MSSel/MSSelectableMainColumn.h
MSSel/MSSelectableTable.h
MSSel/MSSelection.h
MSSel/MSSelectionError.h
MSSel/MSSelectionErrorHandler.h
MSSel/MSSSpwErrorHandler.h
MSSel/MSSelectionKeywords.h
MSSel/MSSelectionTools.h
MSSel/MSSelector.h
MSSel/MSSelUtil.h
MSSel/MSSelUtil.tcc
MSSel/MSSelUtil2.h
MSSel/MSSelUtil2.tcc
MSSel/MSSourceIndex.h
MSSel/MSSpwGram.h
MSSel/MSSpwIndex.h
MSSel/MSSpWindowIndex.h
MSSel/MSSpwParse.h
MSSel/MSStateGram.h
MSSel/MSStateIndex.h
MSSel/MSStateParse.h
MSSel/MSSysCalIndex.h
MSSel/MSTableIndex.h
MSSel/MSTimeDefinitions.h
MSSel/MSTimeGram.h
MSSel/MSTimeParse.h
MSSel/MSUvDistGram.h
MSSel/MSUvDistParse.h
MSSel/MSWeatherIndex.h
DESTINATION include/casacore/ms/MSSel
)

install (FILES
MSOper/MS1ToMS2Converter.h
MSOper/MSConcat.h
MSOper/MSDerivedValues.h
MSOper/MSFlagger.h
MSOper/MSKeys.h
MSOper/MSLister.h
MSOper/MSMetaData.h
MSOper/MSReader.h
MSOper/MSSummary.h
MSOper/MSValidIds.h
MSOper/NewMSSimulator.h
DESTINATION include/casacore/ms/MSOper
)

install (FILES
MeasurementSets.h
MSSel.h
MSOper.h
DESTINATION include/casacore/ms
)

add_subdirectory (MeasurementSets/test ${EXCL_ALL})
add_subdirectory (MSSel/test ${EXCL_ALL})
add_subdirectory (MSOper/test ${EXCL_ALL})

=== python/CMakeLists.txt ===
message(STATUS "Looking for python2 specific environment...")

# tempororarly set variables used by findpython
if (PYTHON2_EXECUTABLE)
    set(PYTHON_EXECUTABLE ${PYTHON2_EXECUTABLE} CACHE FILEPATH "")
endif()

if (PYTHON2_LIBRARY)
    set(PYTHON_LIBRARY ${PYTHON2_LIBRARY} CACHE FILEPATH "")
endif()

if (PYTHON2_INCLUDE_DIR)
set(PYTHON_INCLUDE_DIR ${PYTHON2_INCLUDE_DIR} CACHE FILEPATH "")
endif()

if (PYTHON2_FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs)
    set(FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs ${PYTHON2_FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs} CACHE FILEPATH "")
endif()

# Detect the python properties
set(Python_FIND_VERSION 2)
set(PythonInterp_FIND_VERSION_MAJOR 2)
find_package(Python REQUIRED)
if (PYTHONINTERP_FOUND)
    find_package(Boost REQUIRED COMPONENTS python)
    find_package (NUMPY REQUIRED)

    # copy the variables to their final destination
    set(PYTHON2_EXECUTABLE ${PYTHON_EXECUTABLE} CACHE FILEPATH "Path to Python2 interpreter")
    set(PYTHON2_LIBRARY ${PYTHON_LIBRARY} CACHE PATH "Python2 library")
    set(PYTHON2_INCLUDE_DIR ${PYTHON_INCLUDE_DIR} CACHE PATH "Python2 include folder")
    set(PYTHON2_FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs ${FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs} CACHE STRING "")

    set(PYTHON2_LIBRARIES ${PYTHON_LIBRARIES} PARENT_SCOPE)
    set(PYTHON2_NUMPY_INCLUDE_DIRS ${NUMPY_INCLUDE_DIRS} PARENT_SCOPE)
    set(PYTHON2_Boost_LIBRARIES ${Boost_LIBRARIES} PARENT_SCOPE)
    set(PYTHON2_Boost_INCLUDE_DIRS ${Boost_INCLUDE_DIRS} PARENT_SCOPE)
    set(PYTHON2_Boost_PYTHON_LIBRARY_RELEASE ${Boost_PYTHON_LIBRARY_RELEASE} PARENT_SCOPE)
    set(PYTHON2_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS} PARENT_SCOPE)

    # to access the variables here we also need to set them in the local scope
    set(PYTHON2_LIBRARIES ${PYTHON_LIBRARIES} )
    set(PYTHON2_NUMPY_INCLUDE_DIRS ${NUMPY_INCLUDE_DIRS} )
    set(PYTHON2_Boost_LIBRARIES ${Boost_LIBRARIES} )
    set(PYTHON2_Boost_INCLUDE_DIRS ${Boost_INCLUDE_DIRS} )
    set(PYTHON2_Boost_PYTHON_LIBRARY_RELEASE ${Boost_PYTHON_LIBRARY_RELEASE} )
    set(PYTHON2_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS} )

    # Remove cached variable to not confuse user
    unset(PYTHON_EXECUTABLE CACHE)
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs CACHE)
endif(PYTHONINTERP_FOUND)


include_directories (${PYTHON2_Boost_INCLUDE_DIRS} ${PYTHON2_NUMPY_INCLUDE_DIRS} ${PYTHON2_INCLUDE_DIRS})

add_library (casa_python
Converters/PycArray.cc
Converters/PycArrayNP.cc
Converters/PycBasicData.cc
Converters/PycExcp.cc
Converters/PycImport.cc
Converters/PycRecord.cc
Converters/PycValueHolder.cc
)

target_link_libraries (casa_python casa_casa ${PYTHON2_Boost_LIBRARIES} ${PYTHON2_LIBRARIES} ${CASACORE_ARCH_LIBS})

install (TARGETS casa_python
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Converters/PycArray.h
Converters/PycArrayComCC.h
Converters/PycArrayComH.h
Converters/PycArrayNP.h
Converters/PycBasicData.h
Converters/PycExcp.h
Converters/PycRecord.h
Converters/PycValueHolder.h
Converters/PycArray.tcc
DESTINATION include/casacore/python/Converters
)

install (FILES
Converters.h
DESTINATION include/casacore/python
)

add_subdirectory (Converters/test ${EXCL_ALL})

=== python3/CMakeLists.txt ===
message(STATUS "Looking for python3 specific environment...")

# tempororarly set variables used by findpython
if (PYTHON3_EXECUTABLE)
    set(PYTHON_EXECUTABLE ${PYTHON3_EXECUTABLE} CACHE FILEPATH "")
endif()

if (PYTHON3_LIBRARY)
    set(PYTHON_LIBRARY ${PYTHON3_LIBRARY} CACHE FILEPATH "")
endif()

if (PYTHON3_INCLUDE_DIR)
set(PYTHON_INCLUDE_DIR ${PYTHON3_INCLUDE_DIR} CACHE FILEPATH "")
endif()

if (PYTHON3_FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs)
    set(FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs ${PYTHON3_FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs} CACHE FILEPATH "")
endif()

# Detect the python properties
set(Python_ADDITIONAL_VERSIONS 3.5 3.4)

find_package(Python REQUIRED)

if (PYTHONINTERP_FOUND)
    if (APPLE)
        find_package(Boost REQUIRED COMPONENTS python3)
    else ()
        # NOTE: the name of the python3 version of boost is probably Debian/Ubuntu specific
        find_package(Boost REQUIRED COMPONENTS python-py${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR})
    endif (APPLE)

    find_package (NUMPY REQUIRED)

    # copy the variables to their final destination
    set(PYTHON3_EXECUTABLE ${PYTHON_EXECUTABLE} CACHE FILEPATH "Path to Python3 interpreter")
    set(PYTHON3_LIBRARY ${PYTHON_LIBRARY} CACHE PATH "Python3 library")
    set(PYTHON3_INCLUDE_DIR ${PYTHON_INCLUDE_DIR} CACHE PATH "Python3 include folder")
    set(PYTHON3_FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs ${FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs} CACHE STRING "")

    set(PYTHON3_LIBRARIES ${PYTHON_LIBRARIES} PARENT_SCOPE)
    set(PYTHON3_NUMPY_INCLUDE_DIRS ${NUMPY_INCLUDE_DIRS} PARENT_SCOPE)
    set(PYTHON3_Boost_LIBRARIES ${Boost_LIBRARIES} PARENT_SCOPE)
    set(PYTHON3_Boost_INCLUDE_DIRS ${Boost_INCLUDE_DIRS} PARENT_SCOPE)
    set(PYTHON3_Boost_PYTHON_LIBRARY_RELEASE ${PYTHON3_Boost_LIBRARIES} PARENT_SCOPE)
    set(PYTHON3_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS} PARENT_SCOPE)

    # to access the variables here we also need to set them in the local scope
    set(PYTHON3_LIBRARIES ${PYTHON_LIBRARIES} )
    set(PYTHON3_NUMPY_INCLUDE_DIRS ${NUMPY_INCLUDE_DIRS} )
    set(PYTHON3_Boost_LIBRARIES ${Boost_LIBRARIES} )
    set(PYTHON3_Boost_INCLUDE_DIRS ${Boost_INCLUDE_DIRS} )
    set(PYTHON3_Boost_PYTHON_LIBRARY_RELEASE ${Boost_PYTHON_LIBRARY_RELEASE} )
    set(PYTHON3_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS} )

    # Remove cached variable to not confuse user
    unset(PYTHON_EXECUTABLE CACHE)
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(FIND_PACKAGE_MESSAGE_DETAILS_PythonLibs CACHE)
endif(PYTHONINTERP_FOUND)



include_directories (${PYTHON3_Boost_INCLUDE_DIRS} ${PYTHON3_NUMPY_INCLUDE_DIRS} ${PYTHON3_INCLUDE_DIRS})

add_library (casa_python3
../python/Converters/PycArray.cc
../python/Converters/PycArrayNP.cc
../python/Converters/PycBasicData.cc
../python/Converters/PycExcp.cc
../python/Converters/PycImport.cc
../python/Converters/PycRecord.cc
../python/Converters/PycValueHolder.cc
)


target_link_libraries (casa_python3 casa_casa ${PYTHON3_Boost_LIBRARIES} ${PYTHON3_LIBRARIES})

install (TARGETS casa_python3
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

# don't install headers if python2 cmake logic already installs it
if (NOT BUILD_PYTHON)
    install (FILES
    ../python/Converters/PycArray.h
    ../python/Converters/PycArrayComCC.h
    ../python/Converters/PycArrayComH.h
    ../python/Converters/PycArrayNP.h
    ../python/Converters/PycBasicData.h
    ../python/Converters/PycExcp.h
    ../python/Converters/PycRecord.h
    ../python/Converters/PycValueHolder.h
    ../python/Converters/PycArray.tcc
    DESTINATION include/casacore/python/Converters
    )

    install (FILES
    ../python/Converters.h
    DESTINATION include/casacore/python
    )
endif (NOT BUILD_PYTHON)

=== scimath/CMakeLists.txt ===
#
# CASA Scimath
#

add_library (casa_scimath
Fitting/FittingProxy.cc
Fitting/LSQFit.cc
Fitting/LSQFit3.cc
Fitting/LSQMatrix2.cc
Fitting/LSQMatrix.cc
Functionals/FuncExpression.cc
Functionals/FuncExprData.cc
Functionals/FunctionFactoryErrors.cc
Functionals/FunctionalProxy.cc
Functionals/SerialHelper.cc
Mathematics/ClassicalStatisticsData.cc
Mathematics/Combinatorics.cc
Mathematics/FFTPack.cc
Mathematics/FFTServer.cc
Mathematics/FFTW.cc
Mathematics/GaussianBeam.cc
Mathematics/Geometry.cc
Mathematics/Interpolate2D.cc
Mathematics/MathFunc2.cc
Mathematics/MatrixSolver.cc
Mathematics/MedianSlider.cc
Mathematics/NNLSMatrixSolver.cc
Mathematics/NumericTraits.cc
Mathematics/RigidVector2.cc
Mathematics/SCSL.cc
Mathematics/SquareMatrix2.cc
Mathematics/StatisticsData.cc
Mathematics/VectorKernel.cc
Mathematics/VanVleck.cc
Mathematics/ZScoreCalculator.cc
)

if (FFTW3_FOUND)
    target_link_libraries (casa_scimath casa_scimath_f ${FFTW3_LIBRARIES} ${CASACORE_ARCH_LIBS})
else (FFTW3_FOUND)
    target_link_libraries (casa_scimath casa_scimath_f ${CASACORE_ARCH_LIBS})
endif (FFTW3_FOUND)

install (TARGETS casa_scimath
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_WRITE GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Fitting/FitGaussian.h
Fitting/FitGaussian.tcc
Fitting/FittingProxy.h
Fitting/GenericL2Fit.h
Fitting/GenericL2Fit.tcc
Fitting/LSQFit.h
Fitting/LSQFit2.tcc
Fitting/LSQMatrix.h
Fitting/LSQTraits.h
Fitting/LSQaips.h
Fitting/LSQaips.tcc
Fitting/LinearFit.h
Fitting/LinearFit.tcc
Fitting/LinearFitSVD.h
Fitting/LinearFitSVD.tcc
Fitting/NonLinearFit.h
Fitting/NonLinearFit.tcc
Fitting/NonLinearFitLM.h
Fitting/NonLinearFitLM.tcc
DESTINATION include/casacore/scimath/Fitting
)

install (FILES
Functionals/AbstractFunctionFactory.h
Functionals/ArraySampledFunctional.h
Functionals/ArraySampledFunctional.tcc
Functionals/Chebyshev.h
Functionals/Chebyshev.tcc
Functionals/ChebyshevParam.h
Functionals/ChebyshevParam.tcc
Functionals/Combi2Function.tcc
Functionals/CombiFunction.h
Functionals/CombiFunction.tcc
Functionals/CombiParam.h
Functionals/CombiParam.tcc
Functionals/CompiledFunction.h
Functionals/CompiledFunction.tcc
Functionals/CompiledParam.h
Functionals/CompiledParam.tcc
Functionals/Compound2Function.tcc
Functionals/CompoundFunction.h
Functionals/CompoundFunction.tcc
Functionals/CompoundParam.h
Functionals/CompoundParam.tcc
Functionals/ConstantND.h
Functionals/ConstantND.tcc
Functionals/ConstantNDParam.h
Functionals/ConstantNDParam.tcc
Functionals/DiracDFunction.h
Functionals/DiracDFunction.tcc
Functionals/DiracDParam.h
Functionals/DiracDParam.tcc
Functionals/EclecticFunctionFactory.h
Functionals/EclecticFunctionFactory.tcc
Functionals/EvenPolynomial.h
Functionals/EvenPolynomial.tcc
Functionals/EvenPolynomial2.tcc
Functionals/EvenPolynomialParam.h
Functionals/EvenPolynomialParam.tcc
Functionals/FuncExprData.h
Functionals/FuncExpression.h
Functionals/Function.h
Functionals/Function.tcc
Functionals/Function1D.h
Functionals/FunctionFactoryErrors.h
Functionals/FunctionHolder.h
Functionals/FunctionHolder.tcc
Functionals/FunctionMarshallable.h
Functionals/FunctionOrder.h
Functionals/FunctionOrder.tcc
Functionals/FunctionParam.h
Functionals/FunctionParam.tcc
Functionals/FunctionTraits.h
Functionals/FunctionWrapper.h
Functionals/FunctionWrapper.tcc
Functionals/FunctionalProxy.h
Functionals/GNoiseFunction.h
Functionals/GNoiseFunction.tcc
Functionals/GNoiseParam.h
Functionals/GNoiseParam.tcc
Functionals/Gaussian1D.h
Functionals/Gaussian1D.tcc
Functionals/Gaussian1D2.tcc
Functionals/Gaussian1DParam.h
Functionals/Gaussian1DParam.tcc
Functionals/Gaussian2D.h
Functionals/Gaussian2D.tcc
Functionals/Gaussian2D2.tcc
Functionals/Gaussian2DParam.h
Functionals/Gaussian2DParam.tcc
Functionals/Gaussian3D.h
Functionals/Gaussian3D.tcc
Functionals/Gaussian3D2.tcc
Functionals/Gaussian3DParam.h
Functionals/Gaussian3DParam.tcc
Functionals/GaussianND.h
Functionals/GaussianND.tcc
Functionals/GaussianNDParam.h
Functionals/GaussianNDParam.tcc
Functionals/HyperPlane.h
Functionals/HyperPlane.tcc
Functionals/HyperPlane2.tcc
Functionals/HyperPlaneParam.h
Functionals/HyperPlaneParam.tcc
Functionals/Interpolate1D.h
Functionals/Interpolate1D.tcc
Functionals/KaiserBFunction.h
Functionals/KaiserBFunction.tcc
Functionals/KaiserBParam.h
Functionals/KaiserBParam.tcc
Functionals/Lorentzian1D.h
Functionals/Lorentzian1D.tcc
Functionals/Lorentzian1D2.tcc
Functionals/Lorentzian1DParam.h
Functionals/Lorentzian1DParam.tcc
Functionals/MarshButterworthBandpass.h
Functionals/MarshButterworthBandpass.tcc
Functionals/MarshallableChebyshev.h
Functionals/MarshallableChebyshev.tcc
Functionals/OddPolynomial.h
Functionals/OddPolynomial.tcc
Functionals/OddPolynomial2.tcc
Functionals/OddPolynomialParam.h
Functionals/OddPolynomialParam.tcc
Functionals/PoissonFunction.h
Functionals/PoissonFunction.tcc
Functionals/PoissonFunction2.tcc
Functionals/PoissonParam.h
Functionals/PoissonParam.tcc
Functionals/Polynomial.h
Functionals/Polynomial.tcc
Functionals/Polynomial2.tcc
Functionals/PolynomialParam.h
Functionals/PolynomialParam.tcc
Functionals/PowerLogarithmicPolynomial.h
Functionals/PowerLogarithmicPolynomial.tcc
Functionals/PowerLogarithmicPolynomial2.tcc
Functionals/PowerLogarithmicPolynomialParam.h
Functionals/PowerLogarithmicPolynomialParam.tcc
Functionals/SPolynomial.h
Functionals/SPolynomial.tcc
Functionals/SPolynomialParam.h
Functionals/SPolynomialParam.tcc
Functionals/SampledFunctional.h
Functionals/ScalarSampledFunctional.h
Functionals/ScalarSampledFunctional.tcc
Functionals/SerialHelper.h
Functionals/SimButterworthBandpass.h
Functionals/SimButterworthBandpass.tcc
Functionals/SincFunction.h
Functionals/SincFunction.tcc
Functionals/SincParam.h
Functionals/SincParam.tcc
Functionals/Sinusoid1D.h
Functionals/Sinusoid1D.tcc
Functionals/Sinusoid1D2.tcc
Functionals/Sinusoid1DParam.h
Functionals/Sinusoid1DParam.tcc
Functionals/SpecificFunctionFactory.h
Functionals/UnaryFunction.h
Functionals/UnaryFunction.tcc
Functionals/UnaryParam.h
Functionals/UnaryParam.tcc
Functionals/WrapperBase.h
Functionals/WrapperData.h
Functionals/WrapperParam.h
Functionals/WrapperParam.tcc
DESTINATION include/casacore/scimath/Functionals
)

install (FILES
Mathematics/AutoDiff.h
Mathematics/AutoDiff.tcc
Mathematics/AutoDiffA.h
Mathematics/AutoDiffIO.h
Mathematics/AutoDiffIO.tcc
Mathematics/AutoDiffMath.h
Mathematics/AutoDiffMath.tcc
Mathematics/AutoDiffRep.h
Mathematics/AutoDiffRep.tcc
Mathematics/AutoDiffX.h
Mathematics/ChauvenetCriterionStatistics.h
Mathematics/ChauvenetCriterionStatistics.tcc
Mathematics/ClassicalStatistics.h
Mathematics/ClassicalStatistics.tcc
Mathematics/ClassicalStatisticsData.h
Mathematics/Combinatorics.h
Mathematics/ConstrainedRangeStatistics.h
Mathematics/ConstrainedRangeStatistics.tcc
Mathematics/ConvolveGridder.h
Mathematics/ConvolveGridder.tcc
Mathematics/Convolver.h
Mathematics/Convolver.tcc
Mathematics/DFTServer.h
Mathematics/DFTServer.tcc
Mathematics/FFTPack.h
Mathematics/FFTServer.h
Mathematics/FFTW.h
Mathematics/FitToHalfStatistics.h
Mathematics/FitToHalfStatistics.tcc
Mathematics/FitToHalfStatisticsData.h
Mathematics/GaussianBeam.h
Mathematics/Geometry.h
Mathematics/Gridder.h
Mathematics/Gridder.tcc
Mathematics/HingesFencesStatistics.h
Mathematics/HingesFencesStatistics.tcc
Mathematics/HistAcc.h
Mathematics/HistAcc.tcc
Mathematics/Interpolate2D.h
Mathematics/Interpolate2D2.tcc
Mathematics/InterpolateArray1D.h
Mathematics/InterpolateArray1D.tcc
Mathematics/MathFunc.h
Mathematics/MathFunc.tcc
Mathematics/MatrixMathLA.h
Mathematics/MatrixMathLA.tcc
Mathematics/MatrixSolver.h
Mathematics/MedianSlider.h
Mathematics/NNGridder.h
Mathematics/NNGridder.tcc
Mathematics/NNLSMatrixSolver.h
Mathematics/NumericTraits.h
Mathematics/NumericTraits2.h
Mathematics/RigidVector.h
Mathematics/RigidVector.tcc
Mathematics/SCSL.h
Mathematics/Smooth.h
Mathematics/Smooth.tcc
Mathematics/SparseDiff.h
Mathematics/SparseDiff.tcc
Mathematics/SparseDiffA.h
Mathematics/SparseDiffIO.h
Mathematics/SparseDiffIO.tcc
Mathematics/SparseDiffMath.h
Mathematics/SparseDiffMath.tcc
Mathematics/SparseDiffRep.h
Mathematics/SparseDiffRep.tcc
Mathematics/SparseDiffX.h
Mathematics/SquareMatrix.h
Mathematics/SquareMatrix.tcc
Mathematics/StatAcc.h
Mathematics/StatAcc.tcc
Mathematics/StatsDataProvider.h
Mathematics/StatsDataProvider.tcc
Mathematics/StatisticsAlgorithm.h
Mathematics/StatisticsAlgorithm.tcc
Mathematics/StatisticsAlgorithmFactory.h
Mathematics/StatisticsAlgorithmFactory.tcc
Mathematics/StatisticsData.h
Mathematics/StatisticsIncrementer.h
Mathematics/StatisticsIncrementer.tcc
Mathematics/StatisticsTypes.h
Mathematics/StatisticsTypes.tcc
Mathematics/StatisticsUtilities.h
Mathematics/StatisticsUtilities.tcc
Mathematics/VanVleck.h
Mathematics/VectorKernel.h
Mathematics/ZScoreCalculator.h
DESTINATION include/casacore/scimath/Mathematics
)

install (FILES
Fitting.h
Functionals.h
Mathematics.h
DESTINATION include/casacore/scimath
)

add_subdirectory (Fitting/test ${EXCL_ALL})
add_subdirectory (Functionals/test ${EXCL_ALL})
add_subdirectory (Mathematics/test ${EXCL_ALL})

=== scimath_f/CMakeLists.txt ===
#
# CASA scimath_f
#

add_library (
casa_scimath_f
abshis.f
absmax.f
ADDGRD.f
atmroutines.f
convolvegridder.f
dfftpak.f
dqags.f
fftpak.f
fgridft.f
fgridsd.f
fmosft.f
fwproj.f
getbig.f
grd2d.f
grd2dwts.f
grdde2d.f
grdgauss.f
grdjinc1.f
grdsf.f
hclean.f
lawson.f
maxabs.f
parametricsolver.f
phasol.f
subcom.f
vvroutines.f
)

target_link_libraries (casa_scimath_f casa_tables ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} ${CASACORE_ARCH_LIBS})

install (
TARGETS casa_scimath_f
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== debian/changelog ===
casacore (2.4.1-1) unstable; urgency=low

  [ Ole Streicher ]
  * New upstream version 2.4.1
  * Rediff patches
  * Push Standards-Version to 4.1.2. Switch remaining URL to https

 -- Ole Streicher <olebole@debian.org>  Tue, 19 Dec 2017 12:02:29 +0100

=== debian/control ===
Source: casacore
Priority: optional
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Benda Xu <heroxbd@gentoo.org>, Ole Streicher <olebole@debian.org>
Build-Depends: bison,
               cmake (>= 1.6.2),
               debhelper (>= 9),
               doxygen,
               flex,
               gfortran,
               graphviz,
               libblas-dev,
               libboost-python-dev,
               libcfitsio-dev,
               libfftw3-dev,
               liblapack-dev,
               libncurses5-dev,
               libreadline6-dev,
               python-numpy,
               python3-dev,
               python3-numpy,
               wcslib-dev
Standards-Version: 4.1.2
Section: science
Homepage: https://casacore.github.io/casacore
Vcs-Git: https://anonscm.debian.org/git/debian-astro/packages/casacore.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-astro/packages/casacore.git

Package: casacore-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcasa-casa2 (= ${binary:Version}),
         libcasa-coordinates2 (= ${binary:Version}),
         libcasa-derivedmscal2 (= ${binary:Version}),
         libcasa-fits2 (= ${binary:Version}),
         libcasa-images2 (= ${binary:Version}),
         libcasa-lattices2 (= ${binary:Version}),
         libcasa-meas2 (= ${binary:Version}),
         libcasa-measures2 (= ${binary:Version}),
         libcasa-mirlib2 (= ${binary:Version}),
         libcasa-ms2 (= ${binary:Version}),
         libcasa-msfits2 (= ${binary:Version}),
         libcasa-python2 (= ${binary:Version}),
         libcasa-scimath-f2 (= ${binary:Version}),
         libcasa-scimath2 (= ${binary:Version}),
         libcasa-tables2 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA core library development files
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the files for application development.

Package: casacore-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: casacore-dev
Description: CASA core library (documentation)
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the API documentation.

Package: casacore-tools
Architecture: any
Depends: python, ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Tools built with CASA
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the tools built with CASA core:
 .
  * taql - query language for casacore tables
  * measuresdata - create data tables for measures
  * imageregrid, imagecalc, showtable, showtablelock, findmeastable,
    fits2table, imreorder, casahdf5support, msselect,  image2fits,
    imageslice, etc.

Package: libcasa-casa2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA core modules
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the Core modules: Multi-dimensional arrays, Quantities
 (values with physical units), OS and IO interface classes, Containers (from
 pre-STL era), Miscellaneous modules for exceptions, tasking interface,
 command line input, logging, STL wrappers, and basic math classes and
 functors.
 .
 Most of the code has been developed before STL came into existence, so
 several classes in modules Containers and Utilities are superseded by their
 STL counterparts. However, they are still used in some casacore
 code. Furthermore, some classes offer some extra functionality compared to
 STL.

Package: libcasa-scimath2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA basic mathematical modules
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the mathematical modules n-dimensional functionals,
 linear and non-linear fitting, and miscellaneous.

Package: libcasa-scimath-f2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA scimath F library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the Mathematical modules N-dim functionals,
 linear/non-linear fitting, and miscellaneous.

Package: libcasa-python2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA Python bindings
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the Python2 bindings.

Package: libcasa-python3-2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA Python bindings
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the Python3 bindings.

Package: libcasa-tables2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA table system
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the database-like table system with advanced query
 language (TaQL).

Package: libcasa-measures2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: casacore-data
Multi-Arch: same
Description: CASA measures library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package implements measures (i.e. quantities with references frames) and
 their persistency. Examples are the Hour-angle and Declination of a source at
 a certain time and observatory; an Ra/Dec for a certain mean epoch; an
 apparent frequency at a certain time given in eV; a local sidereal time at an
 observatory. Measures can be converted from one reference frame to another
 (and this possibility is its main reason for existence).

Package: libcasa-lattices2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA lattice library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package implements memory- or disk-based N-dimensional arrays (lattices)
 with masking, regions, expressions, and math.

Package: libcasa-fits2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA FITS library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains a C++ interface to read and write FITS files.

Package: libcasa-ms2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA MeasurementSet library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the data format for visibility data as described in the
 MeasurementSet definition. The MeasurementSet is where all data are
 ultimately to be found in CASA.

Package: libcasa-derivedmscal2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA derived mscal library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains derived MeasurementSet quantities (like hourangle) that
 can be used as virtual table columns or as TaQL user defined functions.

Package: libcasa-msfits2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA msfits library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the mapping of MeasurementSets to/from FITS.

Package: libcasa-coordinates2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA coordinates library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the implementation of coordinates for astronomical
 images.

Package: libcasa-images2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA image processing library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package implements n-dimensional images with masks, coordinates, and
 history.

Package: libcasa-meas2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA functions handling measures
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This module extends TaQL (the Table Query Language) with functions handling
 measures. Currently it can handle directions, epochs, and positions.

Package: libcasa-mirlib2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: CASA mirlib library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
ifeq ($(DEB_HOST_ARCH_CPU),i386)
    export DEB_CXXFLAGS_MAINT_APPEND = -msse -msse2 -mfpmath=sse
endif
ifeq ($(DEB_HOST_ARCH_OS),hurd)
    THREADS=OFF
else
    THREADS=ON
endif

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_INSTALL_RPATH=ON -DUSE_FFTW3=ON -DUSE_HDF5=OFF \
		-DUSE_THREADS=$(THREADS) -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
		-DDATA_DIR=/var/lib/casacore/data -DBUILD_PYTHON3=ON -DBUILD_TESTING=True

override_dh_auto_build-indep:
	doxygen doxygen.cfg
	rm -f doc/html/jquery.js

override_dh_auto_test-indep override_dh_auto_install-indep:

override_dh_auto_test-arch:
	HOME=$(CURDIR) dh_auto_test --max-parallel=1 -a

override_dh_clean:
	rm -rf doc

=== debian/watch ===
version=3
https://github.com/casacore/casacore/releases /casacore/casacore/archive/v(\d[\.\d]+).tar.gz
